module Sort where


--Funktsioon  span2  jaotab listi kaheks esimesest kohast, mis rikub
--binaarset argumentpredikaati.

span2Cont
  :: ([a] -> [a] -> b) -> (a -> a -> Bool) -> [a] -> b
span2Cont c p (x : xs)
  = let
      span2Cont c a zs@ ~(x : xs)
        | null zs || not (p a x)
          = c [a] zs
        | otherwise
          = span2Cont (c . (a :)) x xs
    in
    span2Cont c x xs
span2Cont c _ _
  = c [] []
{-
span2
  :: (a -> a -> Bool) -> [a] -> ([a] , [a])
span2
  = span2Cont (,)
-}

--Funktsioon  segments  jaotab argumentlisti mittekahanevateks juppideks.

segmentsBy
  :: (a -> a -> Ordering) -> [a] -> [[a]]
segmentsBy _   []
  = []
segmentsBy cmp zs
  = let
      c as rs
        = as : segmentsBy cmp rs
      p x y
        = cmp x y /= GT
    in
    span2Cont c p zs
{-
segments :: Ord a => [a] -> [[a]]
segments
  = segmentsBy compare
-}

mergeBy
  :: (a -> a -> Ordering) -> [a] -> [a] -> [a]
mergeBy cmp as@(x : xs) bs@(y : ys)
  = case cmp x y of
      GT
        -> y : mergeBy cmp as ys
      LT
        -> x : mergeBy cmp xs bs
      _
        -> x : y : mergeBy cmp xs ys
mergeBy cmp []          bs
  = bs
mergeBy cmp as          []
  = as

mergePairsBy
  :: (a -> a -> Ordering) -> [[a]] -> [[a]]
mergePairsBy cmp (xs : ys : yss)
  = mergeBy cmp xs ys : mergePairsBy cmp yss
mergePairsBy _   xss
  = xss

sortBy
  :: (a -> a -> Ordering) -> [a] -> [a]
sortBy cmp 
  = let
      ready (_ : _ : _)
        = False
      ready _
        = True
      getSingle [x]
        = x
      getSingle _
        = []
    in 
    getSingle . until ready (mergePairsBy cmp) . segmentsBy cmp

sort
  :: Ord a
  => [a] -> [a]
sort
  = sortBy compare

