-- See moodul defineerib vljatbi ja seonduvad funktsioonid. Vljatp on 
-- abstraktne selles mttes, et tema konstruktorit ei ekspordita.

module Square (
         Sq (),
         OnBoard (onBoard),
         file, rank, square, inDirFrom
       ) where


import Data.Char



{-
Vljatp.
-}

newtype Sq
          = Sq (Int , Int)   -- Liini jrjekorranumber, rea jrjekorranumber
                             -- (loetud alates 1-st).
          deriving (Eq, Ord)


-- Vlja algebralise esituse leidmine.

instance Show Sq
  where

    showsPrec n (Sq (i , j)) as
      = chr (96 + i) : showsPrec n j as


-- Vlja algebralise esituse jrgi vlja tuvastamine.

instance Read Sq
  where

    readsPrec n s
      = [
          (Sq (i , j) , s2)
        |
          c : s1 <- [s],
          let i = ord c - 96,
          onBoard i,
          (j , s2) <- readsPrec n s1,
          onBoard j
        ]


-- Abiklass;  onBoard  phimtteliselt peab kontrollima, kas argument kuulub 
-- malelauale.

class OnBoard a
  where
    onBoard :: a -> Bool


instance OnBoard Int
  where

    onBoard i
      = 0 < i && i <= 8


instance OnBoard Sq
  where

    onBoard (Sq (i , j))
      = onBoard i && onBoard j


-- Vlja liini leidmine.

file
  :: Sq -> Int
file (Sq p)
  = fst p


-- Vlja rea leidmine.

rank
  :: Sq -> Int
rank (Sq p)
  = snd p


-- Liini ja vlja numbrite jrgi vlja leidmine.

square
  :: Int -> Int -> Sq
square
  = curry Sq


-- Vlja leidmine, mis asub antud vlja suhtes antud kahe tisarvuga nidatud
-- kohas.

inDirFrom
  :: Int -> Int -> Sq -> Sq
inDirFrom dx dy i
  = square (file i + dx) (rank i + dy)

